if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_InfoTips_Hook)
    exec("Add-Ons/System_ReturnToBlockland/RTBR_InfoTips_Hook.cs");
   RTB_addInfoTip("Did you know that you can search your macros in your Macro Saver by typing part of the name in the Title box?");
   RTB_addInfoTip("Did you know that the Macro Saver remembers the bricks you used in your macro?");
   RTB_addInfoTip("You can press <key:toggleMacroWindow> to open the Macro Saver while in-game.","You will need to bind a key to open the Macro Saver in the Controls in order to use it!");
}

if(!isObject(macroGui))
	exec("./macroGui.gui");

function toggleMacroWindow(%val)
{
	if(%val)
		if(macroGui.isAwake())
			canvas.popdialog(macrogui);
		else
			canvas.pushdialog(macrogui);
}

function lstMacroList::onWake(%this)
{
   txtMacroSaveName.setValue("");
   txtMacroDesc.setValue("");
	%this.clear();
	%MacroFile = FindFirstFile("config/client/macros/*.txt");
	while (strlen(%MacroFile) > 0)
	{
		%name = getSubStr(%MacroFile,21,strPos(getSubStr(%MacroFile,21,strLen(%MacroFile)),".txt"));
		if(isvalidmacrosave(%MacroFile))
		   %this.addRow(%i++,%name,%i);
		%MacroFile = FindNextFile("config/client/macros/*.txt");
	}
	%this.sort(0,1);
	$LastMacroSelectType = "Auto";
	%this.setSelectedRow(0);
}

package MacroSaver
{
   function ToggleBuildMacroRecording(%val)
   {
      if(%val)
      {
         if($RecordingBuildMacro)
         {
            for(%i=0;%i<10;%i++)
            {
               %contents = $BSD_InvData[%i].uiName;
               if(%contentsArray $= "")
                  %contentsArray = %contents;
               else
                  %contentsArray = %contentsArray@"\t"@%contents;
            }
            $BuildMacroSO.brickArray = %contentsArray;
         }
      }
      Parent::ToggleBuildMacroRecording(%val);
   }
};
activatePackage(MacroSaver);

function resortListWithItems()
{
   %tname = txtMacroSaveName.getValue();
   %this = lstMacroList;
	%this.clear();
	%MacroFile = FindFirstFile("config/client/macros/*.txt");
	while (strlen(%MacroFile) > 0)
	{
		%name = getSubStr(%MacroFile,21,strPos(getSubStr(%MacroFile,21,strLen(%MacroFile)),".txt"));
		if(isvalidmacrosave(%MacroFile) && strPos(strLwr(%name),strLwr(%tname)) >= 0)
		   %this.addRow(%i++,%name,%i);
		%MacroFile = FindNextFile("config/client/macros/*.txt");
	}
	%this.sort(0,1);
}

function isValidMacroSave(%fileName)
{
   if(isFile(%fileName))
   {
      %file = new FileObject();
      if(%file.openForRead(%fileName))
      {
         if(%file.readLine() !$= "")
         {
            %file.delete();
            return 1;
         }
         else
         {
            %file.delete();
            return 0;
         }
      }
      else
      {
         %file.delete();
         return 0;
      }
   }
   else
      return 0;
}

function lstMacroList::onSelect(%this, %id, %text)
{
	txtMacroSaveName.setValue(getField(%text,0));
	txtMacroDesc.setValue(getMacroDesc(getField(%text,0)));
	
	if(%text $= $LastMacroSelect && vectorSub($Sim::Time,$LastMacroSelectT) <= 1 && $LastMacroSelectType !$= "Auto")
	{
	   LoadMacroFromFile();
	}
	$LastMacroSelectType = "";
	$LastMacroSelect = %text;
	$LastMacroSelectT = $Sim::Time;
}

function getMacroDesc(%filename)
{
   %file = new FileObject();
   if(%file.openForRead("config/client/macros/"@%filename@".txt"))
   {
      %file.readLine();
      %macroDesc = %file.readLine();
      %file.close();
      %file.delete();
      %macroDesc = strReplace(%macroDesc,"\\n","\n");
      return %macroDesc;
   }
   else
      return "<<Unable to read Description>>";
}

function SaveMacroToFile(%conf)
{
	%macroName = txtMacroSaveName.getValue();
	if(!isObject($BuildMacroSO) || $BuildMacroSO.numEvents <= 0)
	{
		MessageBoxOK("Ooopsie!","It appears you don't have a macro in use! Please make one, then try again...");
		return;
	}
	if(%macroName $= "")
	{
		MessageBoxOK("Whoops!","Please fill in the Macro Name box, or select a Macro to Overwrite!");
		return;
	}
	if(!isValidFilename(%macroName))
	{
	   MessageBoxOK("Uh Oh!","The Name you entered contains characters that cannot be used in a Filename.");
	   return;
	}
   if(!%conf && isvalidmacrosave("config/client/macros/"@%macroName@".txt"))
   {
      MessageBoxYesNo("Oh Dear!","Are you sure you wish to overwrite the Macro \""@%macroName@"\"?","saveMacroToFile(1);","");
      return;
   }
   
	%file = new FileObject();
	%file.openForWrite("config/client/macros/"@%macroName@".txt");
	%file.writeLine(%macroName);
	//Dumb haxx because I dont remember how to do it
	%description = txtMacroDesc.getValue();
   for(%i=0;%i<getLineCount(%description);%i++)
	{
	   if(%macroDescription $= "")
	      %macroDescription = getLine(%description,%i);
	   else
	      %macroDescription = %macroDescription@"\\n"@getLine(%description,%i);
	}
   %macroDescription = getSubStr(%macroDescription,0,strLen(%macroDescription));
   %file.writeLine(%macroDescription);
   %file.writeLine($BuildMacroSO.brickArray);
   for(%i=0;%i<$BuildMacroSO.numEvents;%i++)
   {
      %event = $BuildMacroSO.event[%i];
      %file.writeLine(%event);
   }
   %file.close();
   %file.delete();
	canvas.popDialog(macroGui);
	clientCmdCenterPrint("<color:00FF00>Your Macro has been saved as <color:FFFFFF>"@%macroName@"<color:00FF00> successfully.",4);
}

function deleteMacro(%conf)
{
   %macroName = txtMacroSaveName.getValue();
	if(%macroName $= "")
	{
		MessageBoxOK("Oh No!","Please select a Macro to Delete!");
		return;
	}

	if(!isvalidmacrosave("config/client/macros/"@%macroName@".txt"))
	{
		MessageBoxOK("Oh Darn...","Sorry, The saved macro with this name could not be found!");
		return;
	}
	
	if(%conf !$= 1)
	{
	   MessageBoxYesNo("Oh Dear!","Are you sure you wish to delete the Macro \""@%macroName@"\"?","deleteMacro(1);","");
	   return;
	}

   %file = new FileObject();
   %file.openForWrite("config/client/macros/"@%macroName@".txt");
   %file.writeLine("");
   %file.close();
   %file.delete();

	lstMacroList::onWake(lstMacroList);
}

function LoadMacroFromFile()
{
	%macroName = txtMacroSaveName.getValue();
	if(%macroName $= "")
	{
		MessageBoxOK("Oh No!","Please select a Macro to Load!");
		return;
	}

	if(!isvalidmacrosave("config/client/macros/"@%macroName@".txt"))
	{
		MessageBoxOK("Oh Darn...","Sorry, The saved macro with this name could not be found!");
		return;
	}

	if(DataBlockGroup.getCount() >= 2)
	{
		%searchGroup = DataBlockGroup.getID();
	}
	else
	{
		%searchGroup = ServerConnection.getID();
	}
	
	$BuildMacroSO.delete();
   %file = new FileObject();
   if(%file.openForRead("config/client/macros/"@%macroName@".txt"))
   {
      %macroName = %file.readLine();
      %macroDesc = %file.readLine();
      %bricksArray = %file.readLine();
      $BuildMacroSO = new ScriptObject()
      {
         class = BuildMacroSO;
      };
      %count = 0;
      while(!%file.isEOF())
      {
         $BuildMacroSO.event[%count] = %file.readLine();
         %count++;
      }
      $BuildMacroSO.numEvents = %count;
      $BuildMacroSO.brickArray = %bricksArray;
   }
   else
   {
      %file.delete();
      canvas.popDialog(macroGui);
      clientCmdCenterPrint("<color:FF0000>Your Macro \"<color:FFFFFF>"@%macroName@"<color:FF0000>\" failed to load\nFile unable to be Opened",4);
      return;
   }

	BSD_ClickClear();
	for(%i=0;%i<10;%i++)
	{
		%foundBrickDB = 0;
		if(getField(%bricksArray,%i) !$= "" && getField(%bricksArray,%i) !$= "-1")
		{
			%bitmapLoc = $BSD_InvIcon[%i];
			for(%j=0;%j<%searchGroup.getCount();%j++)
			{
				%dB = %searchGroup.getObject(%j);
				if(%dB.getClassName() !$= "fxDTSBrickData")
					continue;

				if(%dB.uiName $= getField(%bricksArray,%i) && %dB.uiName !$= "")
				{
					%foundBrickDB = 1;
					%bitmap = %dB.iconName;
					break;
				}
				else if(%db $= getField(%bricksArray,%i))
				{
				   %foundBrickDB = 1;
				   %bitmap = %db.iconName;
				   break;
				}
			}
			if(%foundBrickDB $= 1)
			{
				%bitmapLoc.setBitmap(%bitmap);
				$BSD_InvData[%i] = %dB;
			}
			else
			{
			   %file.delete();
				canvas.popDialog(macroGui);
				clientCmdCenterPrint("<color:FF0000>Your Macro \"<color:FFFFFF>"@%macroName@"<color:FF0000>\" failed to load.\nBricks Invalid",4);
				return;
			}
		}
	}
	%file.delete();
	BSD_BuyBricks();
	UseFirstSlot(1);
	canvas.popDialog(macroGui);
	clientCmdCenterPrint("<color:00FF00>Your Macro \"<color:FFFFFF>"@%macroName@"<color:00FF00>\" has been loaded successfully.",4);
}

//Stolen from Randy
function AddBind(%division, %name, %command)
{
	for(%i=0;%i<$remapCount;%i++)
	{
		if($remapDivision[%i] $= %division)
		{
			%foundDiv = 1;
			continue;
		}
		if(%foundDiv && $remapDivision[%i] !$= "")
		{
			%position = %i;
			break;
		}
	}
	if(!%foundDiv)
	{
		error("Division not found: " @ %division);
		return;
	}
	if(!%position)
	{
		$remapName[$remapCount] = %name;
		$remapCmd[$remapCount] = %command;
		$remapCount++;
		return;
	}
	for(%i=$remapCount;%i>%position;%i--)
	{
		$remapDivision[%i] = $remapDivision[%i - 1];
		$remapName[%i] = $remapName[%i - 1];
		$remapCmd[%i] = $remapCmd[%i - 1];
	}
	$remapDivision[%position] = "";
	$remapName[%position] = %name;
	$remapCmd[%position] = %command;
	$remapCount++;
}
if(!$addedMacroSaveBinds)
{
	AddBind("Recording","Macro Saver","toggleMacroWindow");
	$addedMacroSaveBinds = true;
}